Bug 1862842 - Review Request: icon - Icon programming language
Summary: Review Request: icon - Icon programming language
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Andy Mender
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2020-08-03 02:17 UTC by Eric Smith
Modified: 2020-10-01 01:41 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-09-23 17:12:07 UTC
Type: ---
andymenderunix: fedora-review+


Attachments (Terms of Use)

Description Eric Smith 2020-08-03 02:17:24 UTC
Spec URL: https://fedorapeople.org/~brouhaha/icon/icon.spec
SRPM URL: https://fedorapeople.org/~brouhaha/icon/icon-9.5.20h-1.fc31.src.rpm
Description: Icon is a high-level general-purpose programming language with novel features
including string scanning and goal-directed evaluation.
Fedora Account System Username: brouhaha

Rpmlint gives errors about zero-length files, but those zero-length files are correct and necessary for the Icon library to work.

Rpmlint gives various warnings, of which IMHO the only one of significance is having a ".h" file in a non-devel package I didn't think it made sense to create a -devel subpackage for a single header file, but I'll do that if the reviewer considers it important.

Comment 1 Andy Mender 2020-08-04 20:12:31 UTC
Extra Koji build: https://koji.fedoraproject.org/koji/taskinfo?taskID=48660617

> Name:           icon
> Version:        9.5.20h
> Release:        1%{?dist}
> Summary:        Icon programming language
> License:        Public Domain

licensecheck picked up a couple of files with the NTP license:
icon-9.5.20h/src/xpm/converters/ppmtoxpm.1: NTP License
icon-9.5.20h/src/xpm/converters/ppmtoxpm.c: NTP License
icon-9.5.20h/src/xpm/converters/xpmtoppm.1: NTP License
icon-9.5.20h/src/xpm/converters/xpmtoppm.c: NTP License
icon-9.5.20h/src/xpm/doc/COPYRIGHT: NTP License

More info about the license here: https://opensource.org/licenses/NTP
It's not listed in the Fedora license cheatsheet: https://fedoraproject.org/wiki/Licensing:Main?rd=Licensing#SoftwareLicenses

The text seems similar to the BSD license.

> # libraries
> install -d -m0755 %{buildroot}%{_libdir}/%{name}
> install -p -m0644 -s bin/libcfunc.so %{buildroot}%{_libdir}/%{name}

For the main package, shouldn't this SO file be versioned?

> %files
> # rpmlint will give errors regarding some libdir/icon/*.u1 files being
> # zero-length, but that is correct.
> %license README
> %{_bindir}/icon
> %{_bindir}/icon[tx]
> %{_includedir}/icall.h

If the header is not actually needed for anything, I would remove it / remove the install %{_includedir} lines.

The main review matrix:

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Header files in -devel subpackage, if present.
  Note: icon : /usr/include/icall.h
  See: https://docs.fedoraproject.org/en-US/packaging-
  guidelines/#_devel_packages


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[!]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
     Review: see earlier comment
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
     Note: Using prebuilt packages
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "*No copyright* Public domain", "Public
     domain", "NTP License". 962 files have unknown license. Detailed
     output of licensecheck in
     /home/amender/rpmbuild/SPECS/icon/icon/licensecheck.txt
     Review: see earlier comments
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
     Review: see earlier comments about licensing
[x]: Package contains desktop file if it is a GUI application.
[!]: Development files must be in a -devel package
     Review: see earlier comment
[?]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[?]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 153600 bytes in 24 files.
[x]: Package complies to the Packaging Guidelines
     Review: Yes, except for SO versioning and the lonely header file
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[x]: Uses parallel make %{?_smp_mflags} macro.
     Review: doesn't, but justifiably
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
     Review: tested in Koji
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.


Rpmlint
-------
Checking: icon-9.5.20h-1.fc33.x86_64.rpm
          icon-utils-9.5.20h-1.fc33.x86_64.rpm
          icon-debuginfo-9.5.20h-1.fc33.x86_64.rpm
          icon-debugsource-9.5.20h-1.fc33.x86_64.rpm
          icon-9.5.20h-1.fc33.src.rpm
icon.x86_64: W: name-repeated-in-summary C Icon
icon.x86_64: W: devel-file-in-non-devel-package /usr/include/icall.h
icon.x86_64: E: zero-length /usr/lib64/icon/core.u1
icon.x86_64: E: zero-length /usr/lib64/icon/dialogs.u1
icon.x86_64: E: zero-length /usr/lib64/icon/gobject.u1
icon.x86_64: E: zero-length /usr/lib64/icon/graphics.u1
icon.x86_64: E: zero-length /usr/lib64/icon/grecords.u1
icon.x86_64: E: zero-length /usr/lib64/icon/imutils.u1
icon.x86_64: E: zero-length /usr/lib64/icon/lindrec.u1
icon.x86_64: E: zero-length /usr/lib64/icon/seqfncs.u1
icon.x86_64: E: zero-length /usr/lib64/icon/vidgets.u1
icon.x86_64: E: zero-length /usr/lib64/icon/vrml1lib.u1
icon.x86_64: E: zero-length /usr/lib64/icon/vrml2lib.u1
icon.x86_64: E: zero-length /usr/lib64/icon/xcolor.u1
icon.x86_64: E: zero-length /usr/lib64/icon/xio.u1
icon.x86_64: E: zero-length /usr/lib64/icon/xplane.u1
icon.x86_64: E: zero-length /usr/lib64/icon/xputpixl.u1
icon.x86_64: E: zero-length /usr/lib64/icon/xqueue.u1
icon.x86_64: W: no-manual-page-for-binary iconx
icon-utils.x86_64: W: no-documentation
icon-utils.x86_64: W: no-manual-page-for-binary colrbook
icon-utils.x86_64: W: no-manual-page-for-binary colrpick
icon-utils.x86_64: W: no-manual-page-for-binary fontpick
icon-utils.x86_64: W: no-manual-page-for-binary icon-xgamma
icon-utils.x86_64: W: no-manual-page-for-binary palette
icon-utils.x86_64: W: no-manual-page-for-binary vib
icon-utils.x86_64: W: no-manual-page-for-binary wevents
icon.src: W: name-repeated-in-summary C Icon
5 packages and 0 specfiles checked; 16 errors, 12 warnings.




Rpmlint (debuginfo)
-------------------
Checking: icon-debuginfo-9.5.20h-1.fc33.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
(none): E: no installed packages by name icon-debuginfo
(none): E: no installed packages by name icon
(none): E: no installed packages by name icon-debugsource
(none): E: no installed packages by name icon-utils
0 packages and 0 specfiles checked; 0 errors, 0 warnings.



Unversioned so-files
--------------------
icon: /usr/lib64/icon/libcfunc.so

Source checksums
----------------
https://github.com/gtownsend/icon/archive/v9.5.20h/icon-v9.5.20h.tar.gz :
  CHECKSUM(SHA256) this package     : 04d3a6830e7674081a9074335a0ad43a8a37c9718f0a39d185f587ee06021829
  CHECKSUM(SHA256) upstream package : 04d3a6830e7674081a9074335a0ad43a8a37c9718f0a39d185f587ee06021829


Requires
--------
icon (rpmlib, GLIBC filtered):
    libX11.so.6()(64bit)
    libc.so.6()(64bit)
    libdl.so.2()(64bit)
    libm.so.6()(64bit)
    libpthread.so.0()(64bit)
    rtld(GNU_HASH)

icon-utils (rpmlib, GLIBC filtered):
    /usr/bin/sh
    icon(x86-64)

icon-debuginfo (rpmlib, GLIBC filtered):

icon-debugsource (rpmlib, GLIBC filtered):



Provides
--------
icon:
    icon
    icon(x86-64)

icon-utils:
    icon-utils
    icon-utils(x86-64)

icon-debuginfo:
    debuginfo(build-id)
    icon-debuginfo
    icon-debuginfo(x86-64)

icon-debugsource:
    icon-debugsource
    icon-debugsource(x86-64)

Comment 2 Andy Mender 2020-09-06 08:37:47 UTC
> licensecheck picked up a couple of files with the NTP license:
> icon-9.5.20h/src/xpm/converters/ppmtoxpm.1: NTP License
> icon-9.5.20h/src/xpm/converters/ppmtoxpm.c: NTP License
> icon-9.5.20h/src/xpm/converters/xpmtoppm.1: NTP License
> icon-9.5.20h/src/xpm/converters/xpmtoppm.c: NTP License
> icon-9.5.20h/src/xpm/doc/COPYRIGHT: NTP License

I asked Fedora Legal regarding the NTP license when reviewing another package and the text matches one of the MIT license variants so it's okay to put "MIT" in the License field for these files so kind of like this:
> # xpm/converters/ppmtoxpm.*: MIT licensed
> # xpm/converters/xpmtoppm.*: MIT licensed
> License: Public Domain and MIT

> BuildRequires:  libX11-devel
> BuildRequires:  libXt-devel

Both of these provide pkgconfig files, hence one could/should use something like this instead:
BuildRequires:  pkgconfig(x11)
BuildRequires:  pkgconfig(xt)

Let me know if you need further help with improving the SPEC file :).

Comment 3 Eric Smith 2020-09-13 00:05:32 UTC
The easiest thing to do for the xpm library is delete the bundled library and use the system library in its place. I now have that working.

Spec URL: https://fedorapeople.org/~brouhaha/icon/icon.spec
SRPM URL: https://fedorapeople.org/~brouhaha/icon/icon-9.5.20h-2.fc31.src.rpm

I could move icall.h to a -devel subpackage, but it would be the only file in that subpackage, which is why I hadn't done that. If you really think that's the right thing, I'll do it.

I'm reluctant to version the .so because:
1)  upstream doesn't version it, and Icon programs that use it wouldn't know to look for a versioned library.
2)  it's not intended for use by any other package. The only use of it is by Icon programs, to call external C functions that weren't necessarily intended to be called by Icon. It's not anything useful for non-Icon programs as might be present in other Fedora packages. As such, it might be better placed in libexec, but Icon programs wouldn't know to look for it there, so I'd rather leave it in libdir.

Comment 4 Andy Mender 2020-09-13 08:42:04 UTC
> The easiest thing to do for the xpm library is delete the bundled library and use the system library in its place. I now have that working.

Awesome!

> I could move icall.h to a -devel subpackage, but it would be the only file in that subpackage, which is why I hadn't done that. If you really think that's the right thing, I'll do it.

I had a look at the icall.h header. I don't think it's worth creating a separate -devel package. You can keep it in the main package. Also, correct me if I'm wrong, but it's needed by the main Icon binary itself, right?

As for versioning of the SO file, if the shared library is internal to Icon, it doesn't need to be versioned.

There was a new release recently: https://github.com/gtownsend/icon/releases/tag/v9.5.20i
Could you bump the version in the SPEC file accordingly? :)

Other than that, package approved!

Comment 5 Eric Smith 2020-09-13 21:17:41 UTC
Thanks for reviewing! I don't think the icon binary itself needs the icall.h header. I believe it is provided for the purpose of building add-on modules, so conceptually I think it would belong in a -devel subpackage, but it sounds like we're in agreement that it's not worth having a subpackage for just the one header file.

I updated to 9.5.20i per your request, so I think this is ready to go.

Spec URL: https://fedorapeople.org/~brouhaha/icon/icon.spec
SRPM URL: https://fedorapeople.org/~brouhaha/icon/icon-9.5.20i-1.fc31.src.rpm

Comment 6 Gwyn Ciesla 2020-09-14 01:55:04 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/icon

Comment 7 Fedora Update System 2020-09-15 16:29:19 UTC
FEDORA-2020-5b94659fbd has been submitted as an update to Fedora 32. https://bodhi.fedoraproject.org/updates/FEDORA-2020-5b94659fbd

Comment 8 Fedora Update System 2020-09-15 17:03:58 UTC
FEDORA-EPEL-2020-bca491b47c has been submitted as an update to Fedora EPEL 8. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2020-bca491b47c

Comment 9 Fedora Update System 2020-09-16 14:30:06 UTC
FEDORA-2020-5b94659fbd has been pushed to the Fedora 32 testing repository.
In short time you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2020-5b94659fbd \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-5b94659fbd

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 10 Fedora Update System 2020-09-16 14:58:28 UTC
FEDORA-EPEL-2020-bca491b47c has been pushed to the Fedora EPEL 8 testing repository.

You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2020-bca491b47c

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 11 Fedora Update System 2020-09-23 17:12:07 UTC
FEDORA-2020-5b94659fbd has been pushed to the Fedora 32 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 12 Fedora Update System 2020-10-01 01:41:55 UTC
FEDORA-EPEL-2020-bca491b47c has been pushed to the Fedora EPEL 8 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.